import * as React from "react";
import * as Immtable from "immutable";
import { ISelected } from "./combo";
declare type props = {
    tit: string;
    selected: Immtable.List<ISelected>;
    field: string;
    defaultEditVal?: string;
    formatterVal?: (selected: props["selected"]) => React.ReactChild;
    editFn?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    drop: boolean;
    noicon?: boolean;
    noRequire?: boolean;
    disabled?: boolean;
    ableClear?: boolean;
    slideFn(e: React.MouseEvent): void;
    clearFn(): void;
};
declare type states = {
    editVal: string;
    blurVal: string;
    preSelected: Immtable.List<ISelected>;
};
declare class ComboInp extends React.PureComponent<props, states> {
    static defaultProps: {
        formatterVal: (seleted: props["selected"]) => string;
        defaultEditVal: string;
    };
    static getDerivedStateFromProps(nextProps: props, preState: states): Partial<states> | null;
    state: states;
    getSlideIcon(noicon: boolean | undefined, drop: boolean): JSX.Element | undefined;
    getTit(tit: string): JSX.Element;
    getClearCom(show: boolean): JSX.Element | undefined;
    clickFn: (e: React.MouseEvent<HTMLSpanElement>) => void;
    changeEditInp: (e: React.ChangeEvent<HTMLInputElement>) => void;
    blurEditFn: () => void;
    render(): JSX.Element;
}
export default ComboInp;
