import * as React from "react";
import { Idrop, treeNode } from "./combo";
import { IImmutalbeList } from "../util/immutableUtil";
declare type immutableData<T> = IImmutalbeList<treeNode<T>>;
declare type props<T> = {
    node: treeNode<T>;
    fieldObj: Idrop<"tree", T>["filedObj"];
    index: string;
    lev: number;
    formatterDropItem?: Idrop<"tree", T>["formatterDropItem"];
    checkMethod(value: string): void;
    checkForPar(value: string): void;
    clickFn(index: string): void;
    toggleExpand(index: string): void;
};
declare type states = {};
interface IParTreeItem {
    toggleExpandFn(e: React.MouseEvent<HTMLDivElement>): void;
}
declare class ParTreeItem<T extends AnyObj> extends React.PureComponent<props<T>, states> implements IParTreeItem {
    static defaultProps: {
        childField: string;
    };
    state: states;
    checkFn: (e: React.ChangeEvent<HTMLInputElement>) => void;
    getCheckbox(text: string, expand: boolean): JSX.Element;
    getSubCom(childArr: immutableData<T>, lev: number, oindex: string): import("immutable").List<JSX.Element>;
    toggleExpandFn: (e: React.MouseEvent<HTMLDivElement>) => void;
    clickFn: (e: React.MouseEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}
export default ParTreeItem;
