import * as React from "react";
declare type props = {
    msg?: string;
    type?: "crash" | "noFind";
    init: {
        init: boolean;
    };
    bindGetHasError?: (getHasErrorFn: () => boolean) => void;
    children: React.ReactNode;
};
declare type states = {
    hasError: boolean;
    preInit: {
        init: boolean;
    };
};
export default class ErrorBoundary extends React.Component<props, states> {
    static getDerivedStateFromProps(nextProps: props, preState: states): Partial<states> | null;
    static getDerivedStateFromError(): {
        hasError: boolean;
    };
    state: states;
    constructor(prop: props);
    getHasError: () => boolean;
    reload: () => void;
    componentDidCatch(): void;
    render(): React.ReactNode;
}
export {};
