import * as React from "react";
import { IColumnItem, ITableStates, fieldObj, Inode } from "./mytable";
import { IScrollMethods } from "../../scroll/scroll";
import { IImmutalbeMap, IImmutalbeList } from "../../util/immutableUtil";
declare type Props<T> = {
    data: T[];
    children: (React.ReactElement<IColumnItem<T>> | undefined)[];
    hasBorder?: boolean;
    noOrder?: boolean;
    height?: number;
    autoHeight?: boolean;
    noPageNums?: boolean;
    idField: string;
    checkbox?: boolean;
    defaultSel?: string;
    canSelectField?: string;
    tabField?: string;
    emptyTxt?: string | ((tabField?: string) => React.ReactChild);
    initSelectVal?: {
        id: string;
    };
    bindGetSelectedFn?: (getSelected: () => IImmutalbeList<IImmutalbeMap<Inode & T>>) => void;
};
declare type States<T> = ITableStates<T>;
interface ITable<T> {
    fieldObj: fieldObj<T>;
}
declare enum checkAllStataus {
    hasChecked = "hasCheck",
    checked = "checked",
    noChecked = "noChecked"
}
declare class Table<T extends AnyObj> extends React.PureComponent<Props<T>, States<T>> implements ITable<T> {
    static defaultProps: {
        defaultSel: string;
        emptyTxt: string;
        canSelectField: string;
    };
    static colItem: <K extends AnyObj>({ width, children, align, }: React.PropsWithChildren<IColumnItem<K>>) => JSX.Element;
    static getDerivedStateFromProps(nextProps: Props<AnyObj>, preState: States<AnyObj>): null | Partial<States<AnyObj>>;
    fieldObj: {
        idField: string;
        checkbox: boolean | undefined;
        column: IColumnItem<T>[];
        tabField: string | undefined;
        noPageNums: boolean | undefined;
        noOrder: boolean | undefined;
        canSelectField: string;
    };
    tableContainer: React.RefObject<HTMLDivElement>;
    scrollMethod: IScrollMethods | undefined;
    constructor(props: Props<T>);
    shouldComponentUpdate(nextProps: Readonly<Props<T>>): boolean;
    bindScrollMethods: (methods?: IScrollMethods | undefined) => void;
    getSelected: () => IImmutalbeList<IImmutalbeMap<Inode & T, Inode & T>>;
    componentDidMount(): void;
    getSnapshotBeforeUpdate(preProps: Props<T>): true | null;
    componentDidUpdate(preProps: Props<T>, _preState: States<T>, snapshot: AnyObj): void;
    initFixObj(props: Props<T>): {
        idField: string;
        checkbox: boolean | undefined;
        column: IColumnItem<T>[];
        tabField: string | undefined;
        noPageNums: boolean | undefined;
        noOrder: boolean | undefined;
        canSelectField: string;
    };
    scrollToSeletItem(): void;
    getColGroupCom(): JSX.Element;
    checkCurPageAll: (e: React.ChangeEvent<HTMLInputElement>) => void;
    getCurPageData(): IImmutalbeList<IImmutalbeMap<Inode & T, Inode & T>>;
    countCurPageTotalStatus(): checkAllStataus;
    getFixHead(): JSX.Element;
    changeState: <P extends keyof ITableStates<T>>(field: P, data: States<T>[P]) => void;
    getTableBody(): JSX.Element;
    selectedHandle: (e: React.MouseEvent<HTMLTableCellElement>) => void;
    render(): JSX.Element;
}
export default Table;
