import React from "react";
import { IImmutalbeMap, IImmutalbeList } from "../../util/immutableUtil";
export interface IColumnItem<T> {
    field: string;
    children: React.ReactNode;
    width: number;
    align?: "center" | "left" | 'right';
    formatter?: (node: IImmutalbeMap<Inode & T>, index: number, tabField: string, field: string) => React.ReactChild;
}
declare type group<T> = React.ComponentElement<IColumnItem<T>, React.ComponentState>;
export interface Inode {
    checked: boolean;
}
export interface ICommon<T> {
    node: Inode & T;
    col: (Omit<IColumnItem<T>, 'children'> & {
        text: React.ReactNode;
    });
    data: IImmutalbeList<IImmutalbeMap<ICommon<T>['node']>>;
    groupCol: {
        children: group<T>[] | group<T>;
        forzen?: boolean;
        width?: number;
    };
    config: {
        child: ICommon<T>['col'][];
        width: number;
        forzen?: boolean;
    };
    fixObj: {
        slectField?: string;
        multiply?: boolean;
        idField: string;
        defaultSel: string;
        tabField: string;
        emptyTxt: string | ((tabField?: string) => React.ReactChild);
        noOrder?: boolean;
    };
    changeState(path: string, key: '' | 'active' | 'checkPar'): void;
}
export declare type fieldObj<T> = {
    column: IColumnItem<T>[];
    idField: string;
    noOrder?: boolean;
    checkbox?: boolean;
    tabField?: string;
};
export {};
