import * as Immutable from "immutable";
export declare type AllowedValue = string | number | boolean | IAllowedMap | IAllowedList | IImmutalbeMap<AnyObj> | AnyObj;
declare type IAllowedMap = Immutable.Map<string, AllowedValue>;
declare type IAllowedList = Immutable.List<AllowedValue>;
export declare type MapTypeAllowedData<DataType> = {
    [K in keyof DataType]: DataType[K];
};
export interface IImmutalbeMap<DataType extends MapTypeAllowedData<DataType>, origin extends AnyObj = DataType> extends Immutable.Map<keyof DataType, AllowedValue> {
    toJS(): origin;
    get<K extends keyof DataType>(key: K, notSetValue?: DataType[K]): DataType[K];
    set<K extends keyof DataType>(key: K, value: DataType[K]): this;
    update<K extends keyof DataType>(key: K, updater: (value: DataType[K]) => DataType[K]): this;
    update<K extends keyof DataType>(key: K, notSetValue: DataType[K], updater: (value: DataType[K]) => DataType[K]): this;
    update<R>(updater: (value: this) => R): R;
    updateIn<R = any>(path: string | string[], updater: (value: R) => R): this;
}
export declare type IImmutalbeList<DataType extends AllowedValue> = Immutable.List<DataType>;
export declare type ImmuTreeNode<T extends AnyObj, K extends string = "children"> = Omit<T, K> & {
    [f in K]: IImmutalbeList<IImmutalbeMap<ImmuTreeNode<T, f>, T>>;
};
export declare type immuObjArr<T extends AnyObj, K extends keyof T> = Omit<T, K> & {
    [f in K]: T[f] extends AnyObj[] ? IImmutalbeList<IImmutalbeMap<T[f][0]>> : IImmutalbeMap<T[f]>;
};
export {};
